; ,  /    V2.1			
; PIC16F628A,    PIC16F628                
;     1
; : A7, B6, B1, A2, A3, A6, B0, B3 -  220  (A,B,C,D,E,F,G,H)
; : A1, A0, B7, B2 (1 ) -   
;  -    ,  .
;  - 1820 -  4,  47.
;    100 :         :)

                 LIST P=16F628A  
                 #include <P16F628A.inc>
 		__CONFIG 3D54H			;  -  , 
		 radix    hex
;--------------------------------------------------------------------------------------------------
;                         ---   ---
;--------------------------------------------------------------------------------------------------
	CBLOCK	0x20	;   ,  8 + CRC    
		BIT0	;   
		BIT1	;  -//-
		BIT2	;   
		BIT3	;  
		BIT4	;  	
		BIT5	; : FFh
		BIT6	; : 0Ch
		BIT7	; : 10h
		BIT_CRC	;  R
		CRC_PIC	; CRC  
		T_DT_L			;   
		T_DT_H			;      DT ( BIT0  BIT1,    )
		DIG1,DIG2,DIG3,DIG4		;         
		DIG			;        ,    1
		TEMP			;  
		EDINICY			; 
		DESYTKI			;     HEX/DEC
		SOTNY			; -//- 
		PAUZA			;  
		CYKL_8			;    9  
		PAUZA_8			; ,  
		TMP_STATUS		;      
		TMP_W			;   
		CYKL			;  
	ENDC				;   
	ORG 0	
		BCF	STATUS,RP0
		BCF	STATUS,RP1	;   ,  				
		GOTO	SETUP		;    
;--------------------------------------------------------------------------------------------------
;			---   ---
;--------------------------------------------------------------------------------------------------
	ORG 0x04				;  
INT_T1		CLRWDT			;  -  
		MOVWF	TMP_W		;  
		MOVFW	STATUS		;  ""
		MOVWF	TMP_STATUS	;  ,       
		MOVLW	0x03		; ,    
		ANDWF	DIG,W		;    ...
		ADDWF	PCL,F		;    -  3
		GOTO	DIG_1		;      
		GOTO	DIG_2		;  ,
		GOTO	DIG_3		;       
		GOTO	DIG_4		;  -  - 
DIG_1		BSF	PORTB,0x02	;    
		MOVFW	DIG1		;     
		CALL	DESH		; 
		MOVWF	PORTA		;   
		MOVFW	DIG1		;   
		ADDLW	0x0F		;  "10"   
		CALL	DESH		; 
		MOVWF	PORTB		;    	
		BCF	PORTA,0x01	;   
		nop			;   
		GOTO	EX_INT_T1		;  
DIG_2		BSF	PORTA,0x01	;    
		MOVFW	DIG2		;     
		CALL	DESH		; 
		MOVWF	PORTA		;   
		MOVFW	DIG2		;   
		ADDLW	0x0F		;  "10"   
		CALL	DESH		; 
		MOVWF	PORTB		;    	
		BCF	PORTB,0x05	;   
		nop			;   
		GOTO	EX_INT_T1		;  
DIG_3		BSF	PORTB,0x05	;    
		MOVFW	DIG3		;     
		CALL	DESH		; 
		MOVWF	PORTA		;   
		MOVFW	DIG3		;   
		ADDLW	0x0F		;  "10"   
		CALL	DESH		; 
		MOVWF	PORTB		;    	
		BCF	PORTB,0x07	;   
		BCF	PORTB,0x03	; 
		GOTO	EX_INT_T1		;  
DIG_4		BSF	PORTB,0x07	;    
		MOVFW	DIG4		;     
		CALL	DESH		; 
		MOVWF	PORTA		;   
		MOVFW	DIG4		;   
		ADDLW	0x0F		;  "10"   
		CALL	DESH		; 
		MOVWF	PORTB		;    	
		BCF	PORTB,0x02	;   
		nop			;   
		GOTO	EX_INT_T1		;  
EX_INT_T1		INCF	DIG,F		;    1
		MOVLW	0xFE		; 
		MOVWF	TMR1H		;      1
		CLRF	TMR1L		; -//- ,   2  
		MOVFW	TMP_STATUS	;
		MOVWF	STATUS		;  
		SWAPF	TMP_W,F		;  
		SWAPF	TMP_W,W		;  ,    "Z"
		BCF	PIR1,0		;      TMR1
		RETFIE			;       GIE
;--------------------------------------------------------------------------------------------------
;                          ---  ---
;--------------------------------------------------------------------------------------------------
		;   7-. 
DESH	ADDWF	PCL,F	;  = 0,1,2,3,4,5,6,7,8,9,-,E,r,o," "
	DT	0X33,0XFF,0X73,0X7B,0XBF,0X3B,0X33,0X7F,0X33,0X3B,0XFF,0X33,0XF7,0XF3,0XFF	;   
	DT	0XBD,0XBD,0XBE,0XBC,0XBC,0XFC,0XFC,0XBD,0XBC,0XBC,0XFE,0XFE,0XFE,0XFC,0XFF	;   
DES_ZN	ADDWF	PCL,F
	DT	0,1,1,2,2,3,4,4,5,6,6,7,7,8,9,9			;  
;--------------------------------------------------------------------------------------------------


;--------------------------------------------------------------------------------------------------
;		---   ---
;--------------------------------------------------------------------------------------------------
SETUP	CLRF	PORTA
	CLRF	PORTB
	BSF	STATUS,RP0	;   
	CLRF	TRISA		;   -  
	CLRF	TRISB		;   -  
	BCF	STATUS,RP0	;   
	MOVLW	0xFF
	MOVWF	PORTA		;  
	MOVWF	PORTB		;         "1",  
	MOVLW	0x07		;  ( )
	MOVWF	CMCON		;  
	CLRWDT			;  
	CLRF	TMR0		;   0
	BSF	STATUS,RP0	;   
	CLRF	VRCON		;    
	MOVLW	0x0F		;   
	MOVWF	OPTION_REG	;  128  WDT, TMR0 - 
	CLRWDT			;  		;  
	MOVLW	0x01		; 
	MOVWF	PIE1		;    1 ( PIR1(0x0C),TMR1IF(0))
	BCF	STATUS,RP0	;   
	MOVLW	0x40		; 00000100
	MOVWF	INTCON		;    
	MOVLW	0x35		; 00110101
	MOVWF	T1CON		;  1:  , 1/8
	MOVLW	d'21'		;    ""
	MOVWF	CYKL		;  
	MOVLW	0x20		;     
	MOVWF	FSR		;     020 ()
	CLRF	INDF		;   -       
	INCF	FSR,F		;    
	DECFSZ	CYKL,F		; ,   
	GOTO	$-0x03		;   "0"
	MOVLW	0x0E		;   
	MOVWF	DIG1		;    ""
	MOVWF	DIG2		;   ,   
	MOVWF	DIG3		; ,   
	MOVWF	DIG4		;    ,  )  "85" ???		
	BSF	INTCON,GIE	;   
;--------------------------------------------------------------------------------------------------
START	MOVLW	0xFC		;   = 0
	ANDWF	DIG,W		; (   
	SUBLW	0x04		;       
	BNZ	START_1		;
	CALL	RES_DT		;  
	TSTF	TEMP		; ,   ...
	BZ	DT_OFF		; ( TEMP = 0 -  )
	MOVLW	0x04		;     ,    ""
	ADDWF	DIG,F		;
START_1	MOVLW	0xFC		;
	ANDWF	DIG,W		;
	SUBLW	0x08		;   = 8
	BNZ	START_2		;
DT_CC1	MOVLW	0xCC
	MOVWF	TEMP		; Skip ROM
	CALL	W_1W		;
DT_44	MOVLW	0x44
	MOVWF	TEMP		; Convert
	CALL	W_1W		;
	MOVLW	0x04		; ,    
	ADDWF	DIG,F		;     ,  750   12  DS18B20
START_2	MOVLW	0xFC		;
	ANDWF	DIG,W		;
	SUBLW	0x10		;
	BNZ	START		;
	CALL	RES_DT		;    ,   
	TSTF	TEMP		;     ()
	BZ	DT_OFF		;    -   
	MOVLW	0x04		;
	ADDWF	DIG,F		;
	MOVLW	0xCC
	MOVWF	TEMP		; Skip ROM
	CALL	W_1W		;
	MOVLW	0xBE
	MOVWF	TEMP		; Read Scratchpad
	CALL	W_1W		;
;--------------------------------------------------------------------------------------------------
;	 8   CRC   
;--------------------------------------------------------------------------------------------------
R_8BYIT	MOVLW	0x09
	MOVWF	CYKL_8		; ,    
	MOVLW	0x20
	MOVWF	FSR		;      FSR
BIT_2_8	CALL	R_1W		;   (9-)    9    
	MOVFW	TEMP
	MOVWF	INDF		;      
	INCF	FSR,F		;   -> 20 -  
	DECFSZ	CYKL_8,F		; 28 - CRC
	GOTO	BIT_2_8		; ,   8 
	MOVFW	BIT0
	MOVWF	T_DT_L		;    
	MOVFW	BIT1
	MOVWF	T_DT_H		;    
;--------------------------------------------------------------------------------------------------
NEW_CRC	CLRF	CRC_PIC		;      
	MOVLW	0x08
	MOVWF	CYKL_8		;  
	MOVLW	0x20
	MOVWF	FSR		;  
CRC_2	MOVLW	0x08
	MOVWF	CYKL		;    
CRC_1	MOVFW	INDF		;   ,   FSR
	XORWF	CRC_PIC,W		; . CRCPIC  W,   W
	MOVWF     TEMP		;    TEMP1
	RRF       TEMP,W		;  TEMP1   1,   W,    
	MOVFW	CRC_PIC		; CRCPIC --> W (   )
	BTFSC	STATUS,0		;  ""
	XORLW	0x18		;  =0,     
	MOVWF	TEMP		;   TEMP1
	RRF	TEMP,W		;  ,   W
	MOVWF	CRC_PIC		;    CRCPIC
	BCF	STATUS,0		; 0 --> C
	RRF       INDF,F		;     1
	DECFSZ	CYKL,F		;  
	GOTO	CRC_1		;  8 
	INCF	FSR,F		;  
	DECFSZ	CYKL_8,F		;   
	GOTO	CRC_2		;    8 
	MOVFW	BIT_CRC		;    
	SUBWF	CRC_PIC,W		;   
	BZ	CRC_OK		; CRC ,  
;--------------------------------------------------------------------------------------------------
;	--- CRC_ERROR ---
;--------------------------------------------------------------------------------------------------
CRC_ERR	MOVLW	0x0B
	MOVWF	DIG1		; E
	MOVLW	0x0C
	MOVWF	DIG2		; r
	MOVLW	0x0D	
	MOVWF	DIG3		; o
	MOVLW	0x0C
	MOVWF	DIG4		; r
	GOTO	START
;--------------------------------------------------------------------------------------------------
CRC_OK	MOVFW	T_DT_H		; ,  
	MOVWF	TEMP		
	BTFSS	T_DT_H,7		;      = 1   
	GOTO	PLUS		;   "1",   
MINUS	COMF	T_DT_H,F		;  ()
	COMF	T_DT_L,F		;     (     )
	MOVLW	0x01		;  1   
	ADDWF	T_DT_L,F		;   
	SKPNC			; (  "" 
	INCF	T_DT_H,F		;  "1" -     (?)


	
PLUS	MOVLW	0x04		;  4  
	MOVWF	CYKL		; ,    
SDVIG	RLF	T_DT_L,F		;   
	RLF	T_DT_H,F		;        
	DECFSZ	CYKL,F		;  
	GOTO	SDVIG		
;<<<<<<<<
	MOVLW	d'85'		;    
	SUBWF	T_DT_H,W		;     
	BZ	START		; >> 85 <<
;<<<<<<<<
	MOVLW	0xF0		; 1111 0000	
	ANDWF	T_DT_L,F		;  ,    = 0
	SWAPF	T_DT_L,W		;
	CALL	DES_ZN		;  -  ,   
	MOVWF	DIG4		;    4 
	CLRF	DESYTKI		;  ,   ,
	CLRF	SOTNY		;      
	MOVLW	d'100'		;       , 
	SUBWF	T_DT_H,W		;    
	BNC	BOLS_10		; ,  ,      100
	MOVLW	d'100'		;  ,     ,   ,
	SUBWF	T_DT_H,F		;     "0" (   "")   100  
	INCF	SOTNY,F		;       , ..    100     
BOLS_10	MOVLW	d'10'		;     ,  ,   100
	SUBWF	T_DT_H,W		;    ,     ()
	BNC	MENS_10		;  10 ,   
	MOVLW	d'10'		;     ,     10
	SUBWF	T_DT_H,F		;     
	INCF	DESYTKI,F		;   
	GOTO	BOLS_10		;    
MENS_10	MOVFW	T_DT_H		;     0
	MOVWF	DIG3		;   () 
	TSTF	DESYTKI		;   = 0
	BZ	$+0x04		;  4 
	MOVFW	DESYTKI		;  - 
	MOVWF	DIG2		 
	GOTO	$+0x03
	MOVLW	0x0E		; ""       
	MOVWF	DIG2		
	TSTF	SOTNY		;   
	BZ	$+0x04		;  4 
	MOVFW	SOTNY		;  - 
	MOVWF	DIG1		
	GOTO	$+0x03
	MOVLW	0x0E		;        
	MOVWF	DIG1		
	BTFSS	TEMP,0x07		;   T_DT_H,  
	GOTO	START		; 7  = 1
	TSTF	DESYTKI		;
	BNZ	$+0x06
	MOVLW	0x0E
	MOVWF	DIG1
	MOVLW	0x0A
	MOVWF	DIG2
	GOTO	START
	MOVLW	0x0A		; ""   
	MOVWF	DIG1		
	GOTO	START
;--------------------------------------------------------------------------------------------------
DT_OFF	MOVLW	0x0A		;   - ""
	MOVWF	DIG1		;   
	MOVWF	DIG2		;
	MOVWF	DIG3		;
	MOVWF	DIG4		;
	MOVLW	0x04		;
	ADDWF	DIG,F		;
	GOTO	START		;
;--------------------------------------------------------------------------------------------------
;		---   DS18B20 ---
;--------------------------------------------------------------------------------------------------
RES_DT	BCF	PORTA,0x04	;   
	MOVLW	0xA0
	MOVWF	CYKL		; ,  482 
	DECFSZ	CYKL,F		;      "0"
	GOTO	$-0x01		; 0 -   
	BSF	PORTA,0x04	;  
	BSF	STATUS,RP0	
	BSF	TRISA,0x04	;   4  
	BCF	STATUS,RP0	
	CLRF	TEMP		 
	MOVLW	0x03
	MOVWF	CYKL		;    
	DECFSZ	CYKL,F		; 15 
	GOTO	$-0x01		
	MOVLW	0x5C
	MOVWF	CYKL		; 467  (+15=482 -  )
	BTFSS	PORTA,0x04		;  "0"  1-WIRE
	INCF	TEMP,F		;   -> +1	
	DECFSZ	CYKL,F		
	GOTO	$-0x03		;    
	BSF	STATUS,RP0	
	BCF	TRISA,0x04	;  2  
	BCF	STATUS,RP0	
	RETURN			;   
;--------------------------------------------------------------------------------------------------
;		   1-Wire 
;=-------------------------------------------------------------------------------------------------
W_1W	MOVLW	0x08
	MOVWF	CYKL		; 8 
W_1	BCF	INTCON,7
	BCF	PORTA,0x04	; 0 --> 1-Wire (    = 60 )
	MOVLW	0x12
	MOVWF	PAUZA		;  ~14 
	BTFSC	TEMP,0		;      :(
	BSF	PORTA,0x04	; ,   TEMP1 = 1
	RRF	TEMP,F		;   
	DECFSZ	PAUZA,F		;   ~ 45 
	GOTO	$-0x01		; 
	BSF	PORTA,0x04	;  
	BSF	INTCON,7
          DECFSZ	CYKL,F		; 8  ?
	GOTO	W_1		;   - 
	RETURN			;   /   1-Wire
;--------------------------------------------------------------------------------------------------
;		   1-Wire 
;=-------------------------------------------------------------------------------------------------
R_1W	MOVLW	0x08
	MOVWF	CYKL		;   8 
R_1W1	BCF	INTCON,7
	BCF	PORTA,0x04	;  ,   -  
	RRF	TEMP,F		;  ,     
	BSF	STATUS,RP0	;
	BSF	TRISA,0x04	;   4  ""
	BCF	STATUS,RP0	;  2 - 
	MOVLW	0x02
	MOVWF	PAUZA		;   - ,     7  TEMP
	DECFSZ	PAUZA,F		;  15 
	GOTO	$-0x01		
	BCF	TEMP,7		;     
	MOVLW	0x03
	MOVWF	PAUZA		;     
	BTFSC	PORTA,0x04	;    
	BSF	TEMP,7		;       "0"
	DECFSZ	PAUZA,F		;     "0"
	GOTO	$-0x03		;    - 
	MOVLW	0x0A
	MOVWF	PAUZA		;   .
	DECFSZ	PAUZA,F		;      ,   
	GOTO	$-0x01		;    "1"
	BSF	PORTA,0x04	;    ""
	BSF	STATUS,RP0	
	BCF	TRISA,0x04	;  2  "",   1-Wire
	BCF	STATUS,RP0	
          BSF	INTCON,7
	DECFSZ	CYKL,F		; ,   8 ?
	GOTO	R_1W1		;  , 
	RETURN			;   
;--------------------------------------------------------------------------------------------------
	END

